#pragma once

#define DISPID_CUSTOM_BASE						-6000
#define PLUGIN_INTERFACE_VERSION				3

#define PLUGIN_TYPE_DEFAULT						0x00000000
#define PLUGIN_TYPE_NOSAVE						0x00000001

namespace NEB{

	MIDL_INTERFACE("BE9BFB26-6D2E-4BC2-B3EB-31301043DCFA")
	ICore:public IUnknown
	{
	public:
		virtual HRESULT __stdcall NewWindow(BSTR url, BOOL bInherit, VARIANT *pCallback, VARIANT *pContext, IDispatch **ppDispatch) = NULL;
		virtual HWND __stdcall GetWindow() = NULL;
		virtual HRESULT __stdcall GetInterface(BSTR pModuleName, IDispatch **ppDispatch) = NULL;
		virtual HRESULT __stdcall ConvertPathToFullPath(BSTR pPath,BSTR *pNewPath) = NULL;
		virtual HRESULT __stdcall CreateInternalObject(BSTR Name,IDispatch **ppResult) = NULL;
	};

	MIDL_INTERFACE("5DC680BA-377B-4E7C-A737-5FEDD763A63A")
	IVersion:public IUnknown
	{
	public:
		virtual HRESULT __stdcall GetVersion(PDWORD pPluginVersion,PDWORD pVersion) = NULL;
		virtual HRESULT __stdcall GetName(BSTR *pName) = NULL;
		virtual HRESULT __stdcall GetType(PDWORD pType) = NULL;
	};

	MIDL_INTERFACE("111EE8F2-9143-42CC-83D2-9F23C3D84412")
	IPlugin:public IUnknown
	{
	public:
		virtual HRESULT __stdcall Initialize(NEB::ICore *pWindow, IDispatch *pWebbrowser) = NULL;

		virtual HRESULT __stdcall OnNavigateComplete(VARIANT* URL) = NULL;
		virtual HRESULT __stdcall OnDocumentComplete(VARIANT* URL) = NULL;
	};

	typedef HRESULT(__stdcall *CreateInterfaceFunc)(REFIID iid, PVOID *ppObject);

	template <class T1>
	class ATL_NO_VTABLE IPluginImpl :public IPlugin
	{
	public:
		STDMETHOD(Initialize)(NEB::ICore *pWindow, IDispatch *pWebbrowser){ return E_NOTIMPL; }
		STDMETHOD(OnNavigateComplete)(VARIANT* URL){ return E_NOTIMPL; }
		STDMETHOD(OnDocumentComplete)(VARIANT* URL){ return E_NOTIMPL; }
	};

/////////////////////////////////////////////////////////////////////////////////////////////////////////

	enum STREAM_SEEK_METHOD
	{
		ESSM_BEGIN = 0,
		ESSM_CURRENT,
		ESSM_END,
	};

	MIDL_INTERFACE("92F4F789-5735-4852-A8AC-B0B5E5E2DD88")
	IStream : public IDispatch
	{
	public:
		virtual HRESULT __stdcall Read(OUT PBYTE pBuf, DWORD dwLen, OUT PDWORD pdwReaded) = NULL;
		virtual HRESULT __stdcall Write(const BYTE* pBuf, DWORD dwLen, OUT PDWORD pdwWrited) = NULL;
		virtual HRESULT __stdcall Seek(LONGLONG llOffset, STREAM_SEEK_METHOD dwMethod, DWORD64* pNewPos) = NULL;
		virtual HRESULT __stdcall CopyTo(IStream* pDst, DWORD dwLen, OUT PDWORD pdwCopied) = NULL;
		virtual HRESULT __stdcall SetSize(DWORD64 dwdwSize) = NULL;
		virtual DWORD64 __stdcall GetSize() = NULL;
		virtual PBYTE __stdcall GetBuffer() = NULL;
	};

	#define MENU_ID_BASE		2000

	MIDL_INTERFACE("6CA55863-199D-4ed3-BF7F-E0E3E0AEE56D")
	IMenu : public IDispatch
	{
	public:
		virtual HRESULT __stdcall Init(HWND hWnd, HWND hParentWnd, DWORD dwType) = NULL;
		virtual HMENU __stdcall GetMenuHandle() = NULL;

		// ҵӦ˵S_OKδҵS_FALSE
		virtual HRESULT __stdcall Exec(DWORD dwMenuID) = NULL;
	};
}


#define EB_INIT_VERSION_PLUGIN(x1,x2,x3,x4)			class ATL_NO_VTABLE x1 :									\
														public CComObjectRootEx<CComSingleThreadModel>,			\
														public CComCoClass<x1>,									\
													public NEB::IVersion										\
													{															\
													private:													\
														BEGIN_COM_MAP(x1)										\
															COM_INTERFACE_ENTRY(NEB::IVersion)					\
														END_COM_MAP()											\
																												\
													public:														\
														virtual HRESULT __stdcall GetName(BSTR *pName){ return CComBSTR(x2).CopyTo(pName); }			\
														virtual HRESULT __stdcall GetVersion(PDWORD pPluginVersion, PDWORD pVersion)					\
														{																								\
															if (pPluginVersion)																			\
																*pPluginVersion = PLUGIN_INTERFACE_VERSION;												\
																																						\
															if (pVersion)																				\
																*pVersion = x3;																			\
																																						\
															return S_OK;																				\
														}																								\
																																						\
														virtual HRESULT __stdcall GetType(PDWORD pType)													\
														{																								\
															if (pType == NULL)																			\
																return E_INVALIDARG;																	\
																																						\
															*pType = x4;																				\
															return S_OK;																				\
														}																								\
													};																									\

