#include <atlbase.h>
#include <atlcom.h>
#include "IPlugin.h"

#define PLUGIN_NAME				"myPlugin"

CComModule _AtlModule;

EB_INIT_VERSION_PLUGIN(CVersion,"myPlugin",0,PLUGIN_TYPE_DEFAULT);

class ATL_NO_VTABLE CMyPlugin :
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMyPlugin>,
	public NEB::IPluginImpl<CMyPlugin>,
	public IDispatchImpl<IDispatch>
{
private:
	BEGIN_COM_MAP(CMyPlugin)
		COM_INTERFACE_ENTRY(NEB::IPlugin)
		COM_INTERFACE_ENTRY(IDispatch)
	END_COM_MAP()

private:
    virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames( 
        /* [in] */ __RPC__in REFIID riid,
        /* [size_is][in] */ __RPC__in_ecount_full(cNames) LPOLESTR *rgszNames,
        /* [range][in] */ UINT cNames,
        /* [in] */ LCID lcid,
        /* [size_is][out] */ __RPC__out_ecount_full(cNames) DISPID *rgDispId)
	{
		if (CComBSTR(*rgszNames) == "test")
			*rgDispId = DISPID_CUSTOM_BASE;
		else
			*rgDispId = DISPID_UNKNOWN;

		return S_OK;
	}
    
    virtual /* [local] */ HRESULT STDMETHODCALLTYPE Invoke( 
        /* [in] */ DISPID dispIdMember,
        /* [in] */ REFIID riid,
        /* [in] */ LCID lcid,
        /* [in] */ WORD wFlags,
        /* [out][in] */ DISPPARAMS *pDispParams,
        /* [out] */ VARIANT *pVarResult,
        /* [out] */ EXCEPINFO *pExcepInfo,
        /* [out] */ UINT *puArgErr)
	{
		if (dispIdMember == DISPID_CUSTOM_BASE)
		{
			MessageBox(NULL,L"ҵĵһŶ",L"hello world",MB_OK);
			return S_OK;
		}
		
		return DISP_E_UNKNOWNNAME;
	}
};

HRESULT __stdcall CreateInterface(REFIID iid, PVOID *ppObject)
{
	CComPtr<IUnknown> Unknown;

	if (iid == __uuidof(NEB::IVersion))
		CVersion::_CreatorClass::CreateInstance(NULL, IID_IUnknown, (void**)&Unknown);
	else if (iid == __uuidof(NEB::IPlugin))
		CMyPlugin::_CreatorClass::CreateInstance(NULL, IID_IUnknown, (void**)&Unknown);
	else
		return E_NOINTERFACE;

	return Unknown->QueryInterface(iid, ppObject);
}

extern "C" BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	return _AtlModule.DllMain(hInstance, dwReason, lpReserved, NULL, NULL);
}